<template>
  <div class="page">
    <div class="container">
      <div class="page__content">
        <div class="page__title">{{useFirstCharBig(data.title)}}</div>
        <div class="page__description">{{useFirstCharBig(data.body)}}</div>

        <BlogComments :comments="comments"/>
      </div>
    </div>
  </div>
</template>
<script setup lang="ts">
const page = ref(1)
const totalPages = ref(0)
const {params} = useRoute()
const {data} = await useFetch('https://ax-technology-api.vercel.app/posts/' + params.id)
const comments = ref<Comment[]>([])
const router = useRouter()

onMounted(() => {
  window.addEventListener('scroll', useThrottle(() => {
    const bottomOfPage =
        document.documentElement.scrollHeight - window.innerHeight <= window.scrollY + 200;

    if (bottomOfPage && page.value < totalPages.value) {
      page.value++
      loadToScroll(router.currentRoute.value.query);
    }
  }));
})
onUnmounted(() => {
  window.removeEventListener('scroll', loadToScroll);
})
const loadToScroll = async (args: {}) => {
  const loadedComments = await $fetch('https://ax-technology-api.vercel.app/comments/', {
    params: {
      ...args,
      postId: params.id,
      _limit: 5,
      _page: page.value
    },
    onResponse(context) {
      const link = context.response.headers.get('link');
      if (link) {
        totalPages.value = useParseLinkHeader(link);
      }else {
        totalPages.value = 0
      }
    }
  })
  comments.value = [...comments.value as any, ...loadedComments as any]
}
const loadData = async (args: {}) => {
  const loadedComments = await $fetch('https://ax-technology-api.vercel.app/comments/', {
    params: {
      ...args,
      postId: params.id,
      _limit: 5,
      _page: page.value
    },
    onResponse(context) {
      const link = context.response.headers.get('link');
      if (link) {
        totalPages.value = useParseLinkHeader(link);
      }else {
        totalPages.value = 0
      }
    }
  })
  comments.value = loadedComments as any
}

loadToScroll(router.currentRoute.value.query)

onBeforeRouteUpdate((to, from) => {
  page.value = 1
  totalPages.value = 0
  loadData(to.query)
})
type Comment = {
  postId: number
  id: number
  name: string
  email: string
  body: string
}
definePageMeta({
  layout: 'base',
})
type Post = {
  userId: number
  id: string
  title: string
  body: string
}
useHead({
  title: useFirstCharBig((data.value as Post).title),
  meta: [
    {
      name: 'description',
      content: useFirstCharBig((data.value as Post).body),
    },
  ],
})
</script>